# rekey.ps1: key remapper
# v1.0, 2020-06-10, ed <irc.rizon.net>, MIT-licensed
# https://ocv.me/dev/?rekey.ps1
#
# installs a global keyboard hook and performs these remaps:
#   rctrl » alt
#   num/ » tab (iff rctrl)
#
# exit with rctrl-e or killing the exe (both are safe/clean)
#
# based on https://hinchley.net/articles/creating-a-key-logger-via-a-global-system-hook-using-powershell/


Add-Type -TypeDefinition @"
using System;
using System.IO;
using System.Threading;
using System.Diagnostics;
using System.Runtime.InteropServices;
using System.Windows.Forms;

namespace A {
  public class B {
    // probably want to ctrl-f "begin program" past all this boring winapi stuff
    private const int WH_KEYBOARD_LL = 13;

    // https://www.pinvoke.net/default.aspx/Structures/KI.html
    private const uint EV_EXTENDED = 0x1; // maybe needed for numpad keys
    private const uint EV_KEYUP = 0x2;
    private const uint EV_SCANCODE = 0x8;

    // https://www.win.tue.nl/~aeb/linux/kbd/scancodes-1.html
    private const ushort SC_MENU = 0x38;
    private const ushort SC_TAB = 0xf;
    private const ushort SC_LCTL = 0x1d;
    // SC_RCTL = extended(SC_LCTL) = [0xe0, SC_LCTL]

    [DllImport("user32.dll")]
    private static extern uint SendInput (
      uint nInputs,
      [MarshalAs(UnmanagedType.LPArray), In] INPUT[] pInputs,
      int cbSize);

    [DllImport("user32.dll")]
    private static extern IntPtr SetWindowsHookEx(int idHook, HookProc lpfn, IntPtr hMod, uint dwThreadId);
    // ^ very popular with antivirus i bet  ┐(ﾟ∀ﾟ)┌

    [DllImport("user32.dll")]
    private static extern IntPtr CallNextHookEx(IntPtr hhk, int nCode, IntPtr wParam, IntPtr lParam);

    [DllImport("kernel32.dll")]
    private static extern IntPtr GetModuleHandle(string lpModuleName);

    [StructLayout(LayoutKind.Sequential)]
    internal struct INPUT
    {
        public uint Type;
        public INPUT_DATA Data;
    }

    [StructLayout(LayoutKind.Explicit)]
    internal struct INPUT_DATA
    {
        [FieldOffset(0)]
        public HI Hardware;
        [FieldOffset(0)]
        public KI Keyboard;
        [FieldOffset(0)]
        public MI Mouse;
    }

    [StructLayout(LayoutKind.Sequential)]
    internal struct HI
    {
        public uint Msg;
        public ushort ParamL;
        public ushort ParamH;
    }

    [StructLayout(LayoutKind.Sequential)]
    internal struct KI
    {
        public ushort Vk;
        public ushort Scan;
        public uint Flags;
        public uint Time;
        public IntPtr ExtraInfo;
    }

    [StructLayout(LayoutKind.Sequential)]
    internal struct MI
    {
        public int X;
        public int Y;
        public uint MouseData;
        public uint Flags;
        public uint Time;
        public IntPtr ExtraInfo;
    }

    private HookProc hookProc;
    private IntPtr hookId;

    [StructLayout(LayoutKind.Sequential)]
    public class KBDLLHOOKSTRUCT {
      public uint vkCode;
      public uint scanCode;
      public LLKHF flags;
      public uint time;
      public UIntPtr dwExtraInfo;
    }

    [Flags]
    public enum LLKHF : uint {
      EXTENDED = 0x01,
      INJECTED = 0x10,
      ALTDOWN = 0x20,
      UP = 0x80,
    }

    private IntPtr SetHook(HookProc hookProc) {
      IntPtr moduleHandle = GetModuleHandle(Process.GetCurrentProcess().MainModule.ModuleName);
      return SetWindowsHookEx(WH_KEYBOARD_LL, hookProc, moduleHandle, 0);
    }

    private delegate IntPtr HookProc(int nCode, IntPtr wParam, IntPtr lParam);

    // end boilerplate,
    // begin program

    private void Send(bool down, params ushort[] sc) {
      INPUT[] i = new INPUT[sc.Length];
      for (var a = 0; a < sc.Length; a++) {
        i[a] = new INPUT();
        i[a].Type = 1;
        i[a].Data.Keyboard.Scan = sc[a];
        i[a].Data.Keyboard.Flags = EV_SCANCODE + (down? 0:EV_KEYUP);
      }
      SendInput((uint)sc.Length, i, Marshal.SizeOf(typeof(INPUT)));
    }

    bool rctl_down = false;

    private IntPtr HookCallback(int nCode, IntPtr wParam, IntPtr lParam) {
      KBDLLHOOKSTRUCT kbd = (KBDLLHOOKSTRUCT)Marshal.PtrToStructure(lParam, typeof(KBDLLHOOKSTRUCT));
      //Console.WriteLine("[*] " + kbd.scanCode + " // " + wParam.ToString("x") + " // " + kbd.flags + " // " + kbd.dwExtraInfo);
      bool is_down = (kbd.flags & LLKHF.UP) == 0;

      if (nCode < 0 || (kbd.flags & LLKHF.INJECTED) == LLKHF.INJECTED)
        return CallNextHookEx(hookId, nCode, wParam, lParam);

      // be super careful with hardcoded scankeys, you will want to 
      // GetKeyboardLayout + VkKeyScanExW + MapVirtualKeyExW
      // for any keys that may shift according to layout

      if (kbd.scanCode == 29 && (kbd.flags & LLKHF.EXTENDED) == LLKHF.EXTENDED) {
        new Thread(delegate() {
          if (is_down) {
            Console.WriteLine("[*] alt down");
            Send(false, (ushort)0xe0, SC_LCTL); //extended/escaped
            Send(true, SC_MENU);
          }
          else {
            Console.WriteLine("[*] alt up");
            Send(false, SC_MENU);
          }
        }).Start();
        rctl_down = is_down;
        return (IntPtr)1;
      }

      if (rctl_down && kbd.scanCode == 53) { //numDiv
        Console.WriteLine("[*] alt-tab " + (is_down? "down":"up"));
        new Thread(delegate() {
          Send(is_down, SC_TAB);
        }).Start();
        return (IntPtr)1;
      }

      if (rctl_down && kbd.scanCode == 18) { //e
        Console.WriteLine("[+] bye");
        new Thread(delegate() {
          Send(false, SC_MENU);
          Send(false, SC_TAB);
          Application.DoEvents();
          Process.GetCurrentProcess().Kill(); //never fails grass
        }).Start();
        return (IntPtr)1;
      }

      return CallNextHookEx(hookId, nCode, wParam, lParam);
    }

    public void Run() {
      Console.WriteLine("[+] hi");
      hookProc = HookCallback;
      hookId = SetHook(hookProc);
      
      Console.WriteLine("[+] up");
      Application.Run();
      
      // windows does UnhookWindowsHookEx on exit
      Console.WriteLine("[+] bye");
    }
  }
}
"@ -ReferencedAssemblies System.Windows.Forms

(New-Object -TypeName A.B).Run()
